<VirtualHost *:80>
  ServerName {{ server_name }}

  redirect permanent / https://{{ server_name }}/
</VirtualHost>

<VirtualHost *:443>
  ServerName {{ server_name }}

  LogLevel warn

  SSLEngine on
  {% if ssl_self_signed is defined -%}
  SSLCertificateFile /etc/ssl/certs/{{ server_name }}.crt.self_signed
  SSLCertificateKeyFile /etc/ssl/private/{{ server_name }}.key.self_signed
  {% else -%}
  SSLCertificateFile /etc/ssl/certs/{{ server_name }}.crt
  SSLCertificateKeyFile /etc/ssl/private/{{ server_name }}.key
  SSLCertificateChainFile /etc/apache2/ssl.crt/cacerts.pem
  {% endif %}

  # Secure cookies
  Header always edit Set-Cookie ^(.*)$ $1;HTTPOnly;Secure

  SSLProxyEngine on
  # On ne verifie pas le certificat
  SSLProxyVerify none
  SSLProxyCheckPeerCN off

  ProxyPass / https://{{ virtual_host }}:443/
  ProxyPassReverse / https://{{ virtual_host }}:443/

  RewriteEngine on
  RewriteCond %{HTTP:Upgrade} websocket [NC]
  RewriteCond %{HTTP:Connection} upgrade [NC]
  RewriteRule ^/?(.*) "wss://{{ virtual_host }}:443/$1" [P,L]

  <IfModule security2_module>
    SecRuleEngine On
    # Method allowed is a bit restrictive by default (doesn't allow PUT/DELETE)
    SecRuleRemoveById 911100
    # Allowed file extension doesn't allow *.log (used by compile log file)
    SecRuleRemoveById 920440
    # Upload limitations (there's various limitations not only the size which were blocking the requests)
    SecRuleRemoveById 200004
    # SQL injection (this prevent users to write \delete \insert ...)
    SecRuleRemoveById 942360

    # Increase a bit the body size for upload
    SecRequestBodyLimit 131072000
  </IfModule>

</VirtualHost>